#!/usr/bin/python
import simplejson as json
import optparse 
import sys
from gearman import *


def help():
	print "%s -l <OLT> -n <ONT> -u <USER> -p <PASS>" % sys.argv[0]


if __name__ == "__main__":


	parser = optparse.OptionParser()
	parser.add_option("-l", "--olt", dest="olt")
	parser.add_option("-n", "--ont", dest="ont")
	parser.add_option("-u", "--user", dest="user")
	parser.add_option("-p", "--pass", dest="pwd")

	(options, args) = parser.parse_args()
	if options.olt == None or options.ont == None or options.user == None or options.pwd == None:
		help()
		sys.exit(0)


	cmd = {}
	cmd["olt"] = options.olt.upper() 
	cmd["user"] = options.user 
	cmd["pswd"] = options.pwd
	cmd["command"] = "RTRV-ONT:%s:%s::;" % (options.olt.upper(), options.ont)

	print cmd
	
	try :
		s = json.dumps(cmd)
	except:
		print "Impossivel converter comando para json"
		sys.exit(3)

	try:
		client = GearmanClient(["127.0.0.1"])
		ret = client.submit_job('run_olt_command', s)
	except:
		print "Impossivel estabelecer conexao com o gearman"
		sys.exit(3)
	
	if ret.state == JOB_FAILED:
		print "Erro rodando job via gearman."
		sys.exit(3)

	if ret.timed_out:
		print "Timeout executando job"
		sys.exit(3)

	if ret.state != JOB_COMPLETE:
		print "Erro desconhecido rodando job. Estado %s" % ret.state
		sys.exit(3)

	try:
		arr = json.loads(ret.result)
	except:
		print "Impossivel decodificar json de retorno"
		sys.exit(3)
		

	if arr["state"] != 0:
		print arr["pluginOutput"]
		sys.exit(2)

	print arr["commandReturn"];
