#!/usr/bin/python
import threading
import telnetlib
import signal
from time import sleep

class ONT:

	ip = None
	port = None
	user = None
	pswd = None
	#passiveConn = None
	activeConn = None

	def startConnections(self):

		self.activeConn = Conn()
		self.activeConn.ip = self.ip
		self.activeConn.port = self.port
		self.activeConn.user = self.user
		self.activeConn.pswd = self.pswd
		ret = self.activeConn.connect(True)
		if ret:
			print "active connetion sucessfully created"
		else:
			print "fail to create active connection"

		'''
		self.passiveConn = Conn()
		self.passiveConn.ip = self.ip
		self.passiveConn.port = self.port
		self.passiveConn.user = self.user
		self.passiveConn.pswd = self.pswd
		ret = self.passiveConn.connect(False)
		if ret:
			print "passive connetion sucessfully created"
		else:
			print "fail to create passive connection"
		'''

	def stopConnections(self):
		print "STOPPING CONNECTIONS TO ONT"
		try:
			self.activeConn.close()
			#self.passiveConn.close()
		except:
			pass


	def collect(self):

		#self.passiveConn.start()
		self.activeConn.start()



class Conn(threading.Thread):

	ip = None
	port = None
	user = None
	pswd = None
	active = False
	c = None
	timeToClose = False
	timeout = 2

	def connect(self,act = True):

		try :
			self.c = telnetlib.Telnet(self.ip, self.port)
			self.c.read_until("<", self.timeout)
			self.c.write("\r")
			self.c.read_until("TL1 normal session", self.timeout)
			self.c.write("t\r")
			self.c.read_until("Username   : ", self.timeout)
			self.c.write("%s\r" % self.user)
			self.c.read_until("Password   : ", self.timeout)
			self.c.write("%s\r" % self.pswd)
			self.c.read_until("\n<", self.timeout)
			if act:
				self.active = True
				self.c.write("inh-msg-all::all:::;")
				self.c.read_until("\n<", self.timeout)
			else:
				self.c.set_debuglevel(10000)
				self.c.write(";")
				self.c.read_until("\n<", self.timeout)
				
		except EOFError:
			return False


		return True


	def run(self):

		socket = self.c.get_socket()
		BUFSIZE = 4

		while True:

			if self.active:

				self.c.write("rtrv-alm-all::all::;")
				alerts = self.c.read_until("\n<", self.timeout)
				#print alerts
				sleep(3)
				if self.timeToClose == True:
					break

			else:
				chunk = socket.recv(BUFSIZE)
				print chunk
				


				#a = self.c.read_until("\n<",10)
				#a = self.c.read_lazy()
				#a = self.c.read_very_lazy()
				#a = self.c.read_very_eager()
				#a = self.c.read_all()
				#a = self.c.read_until("\r\n;",10)
				#if len(a) == 0:
				#	sleep(1)
				#else:
				#	print a

				if self.timeToClose == True:
					break


	def close(self):
		self.timeToClose = True

con = None
def signalProcessor(signum,stack):
	con.stopConnections()

if __name__ == "__main__":

	signal.signal(signal.SIGINT,signalProcessor)

	con = ONT()
	con.ip = "oltcta3"
	con.port = 1023
	con.user = "script"
	con.pswd = "tpircs"
	con.startConnections()
	con.collect()

	run = True
	while run:

		run = False
		for thread in threading.enumerate():
			if thread is not threading.currentThread():
				if thread.isAlive():
					run = True

		sleep(1)
