#!/usr/bin/perl
use strict;
use JSON;
use Data::Dumper;
use Cache::Memcached;
use DBI;

our $DBHOST = "127.0.0.1";
our $DBPASS = "htt#@!";
our $DBUSER = "horizons";

sub main {

	my $in = 0;
	my $start = 0;
	my @alerts = ();
	my @aux;
	my $ont = "undef";
	my %oaux = {};
	foreach(<STDIN>) {
	
		s/[\r\n\\"]//g;


		if (m/^ +(.+) \d\d-\d\d-\d\d \d\d:\d\d:\d\d$/) {
			$ont = $1;
		}


		if (m/.+\*\//) {
			$start = 1;
			next;
		}
	
		next if (!$start);

		if (m/^ +(.+:.+):$/) {
		
			$in = 1;

			@aux = split(/[,:]/,$1);

			$oaux{'aid'} = $aux[0];
			$oaux{'type'} = $aux[1];
			$oaux{'ntfncde'} = $aux[2];
			$oaux{'cond'} = $aux[3];
		
		} elsif (m/^ +(.+:.+):(.+)$/) {

			@aux = split(/[,:]/,$1);

			my %obj = {};
			$obj{'aid'} = $aux[0];
			$obj{'type'} = $aux[1];
			$obj{'ntfncde'} = $aux[2];
			$obj{'cond'} = $aux[3];
			$obj{'ont'} = $ont;
			$obj{'description'} = $2;
			push(@alerts,\%obj);
		
		} elsif ($in) {
		
			m/^ +(.+)$/;

			my %obj = {};
			$obj{'description'} = $1;
			$obj{'aid'} = $oaux{'aid'};
			$obj{'type'} = $oaux{'type'};
			$obj{'ntfncde'} = $oaux{'ntfncde'};
			$obj{'cond'} = $oaux{'cond'};
			$obj{'ont'} = $ont;

			push(@alerts,\%obj);
			$in = 0;
		
		}
	
	
	}

	save_to_memcache(encode_json \@alerts);

}


sub save_to_memcache {

	my @servers;
	my $json;
	my $memd;

	$json = shift;
	@servers = @{get_servers()};

	foreach(@servers) {
		$memd = new Cache::Memcached({ 
		                              'servers' => [ $_.":11211" ],
		});
		$memd->set("temp_key", $json);
		$memd->disconnect_all;
	}


}


sub get_servers {

	my $query;
	my $dsn;
	my $dbcon;
	my $sth;
	my $h;
	my @ret;

	$dsn = "dbi:mysql:opcfg:$DBHOST:3306";
	$query = "select * from job_servers";

	$dbcon = DBI->connect($dsn, $DBUSER, $DBPASS);

	$sth = $dbcon->prepare($query);
	$sth->execute();
	while($h = $sth->fetchrow_hashref) {
		push(@ret,$$h{'server'});
	}

	$dbcon->disconnect;
	
	return \@ret;

}


&main();

