#!/usr/bin/php -q
<?php 
include_once("/usr/local/opmon/etc/config.php");

if ($argc<6) {
	print "Not enough parameters\n";
	print "check_nisca_utilization.php <hostname> <inteface name> <average_time minutes> <%warn> <%critical>\n";
	print "<hostname> - Name do the host as is registed in Network Utilization\n";
	print "<interface name> - Name do the interface as is registed in Network Utilization\n";
	print "<up/down/up_errors/down_errors/up_discards/down_discards> - Verify up, down, errors or discards>\n";
	print "<average_time minutes> - average of how long in minutes\n";
	print "<%warn> - % for warning state\n";
	print "<%critical> - % for critical state\n";
	exit(1);	
}

$hostname=$argv[1];
$if_name=$argv[2];
$avg_time=$argv[3];
$avg_time=$avg_time*60;
$warning=$argv[4];
$critical=$argv[5];

$ret_array=get_host_id_service_id_by_device_ifname($hostname,$if_name);
if ($ret_array===false) {
	print "$hostname - $if_name not in the SNMP poller\n";
	exit(3);
}

$host_id=$ret_array["host_id"];
$service_id=$ret_array["service_id"];
$ifspeed=$ret_array["nedi_ifspeed"]; // in bps
if ( ($ifspeed===false) || ($ifspeed==0) || ($ifspeed=='') ) {
	print "ifspeed is zero - please fix it in configuration\n";
	exit(3);
}

$date_query=date("Y-m-d H:i:s",time()-$avg_time);

$sql="SELECT * from netperf_$host_id where service_id=$service_id and entry_time>'$date_query'";
$result = do_query($sql, DBNET);
$bandwidth_in=0;
$bandwidth_out=0;
$count=0;
if ($result->RecordCount()>0) { // Service had performance data in opmon 3.5
	while( !$result->EOF ) {
		$obj = array_to_object($result->fields);
		$bandwidth_in=$bandwidth_in+($obj->ifInOctets/$obj->polling_time);
		$bandwidth_out=$bandwidth_out+($obj->ifOutOctets/$obj->polling_time);
		$count++;
		$result->MoveNext();
	}
	$result->Close();
}
else {
	$count=1;
}

$bandwidth_out=round($bandwidth_out*8/$count,0);
$bandwidth_in=round($bandwidth_in*8/$count,0);
$perc_out=round((100*$bandwidth_out)/$ifspeed,2);
$perc_in=round((100*$bandwidth_in)/$ifspeed,2);

$exit_code=0;
if ( ($perc_in>$warning) || ($perc_out>$warning) ) {
	$exit_code=1;
}
if ( ($perc_in>$critical) || ($perc_out>$critical) ) {
	$exit_code=2;
}

print "Download utilization $perc_in% / Upload utilization $perc_out% | Down=$perc_in%;$warning;$critical;0;100 Up=$perc_out%;$warning;$critical;0;100\n";
exit($exit_code);


?>
