#!/usr/bin/perl

($warning, $critical) = @ARGV;

$VERSION="1.1";

$status_log="/usr/local/opmon/var/status.log";
if (not(-e "$status_log")) {
   print "CRITICO - status.log nao existe.\n";
   exit(2);
}

open(STATUS, $status_log);
@status=<STATUS>;
close(STATUS);

$total=0;
$host_down=0;
$host_unreachable=0;
$service_warning=0;
$service_critical=0;
$service_unknown=0;

for ($i=0; $i<=$#status; $i++) {
	if (("$status[$i]" =~ "hoststatus {") || ("$status[$i]" =~ "servicestatus {")) {
		$total++;
	}

	if ("$status[$i]" =~ "hoststatus {") {
		$host_current_state_line=$status[$i+14];
		chomp($host_current_state_line);
		($junk, $check) = split(/[=]/,$host_current_state_line);
		if ($check eq 1) {
			$host_down++;
		}elsif ($check eq 2) {
			$host_unreachable++;
	
		}
	}

	if ("$status[$i]" =~ "servicestatus {") {
		$service_state_line=$status[$i+15];
		chomp($service_state_line);
		($junk, $check) = split(/[=]/,$service_state_line);
		if ($check eq 1) {
			$service_warning++;
		}elsif ($check eq 2) {
			$service_critical++;
		}elsif ($check eq 3) {
			$service_unknown++;
		}
	}

}

$total_host_problem=$host_down+$host_unreachable;
$total_service_problem=$service_warning+$service_critical+$service_unknown;
$total_problem=$total_host_problem+$total_service_problem;
$pct_problem=($total_problem*100)/$total;
$pct_problem=sprintf("%.02f",$pct_problem);

if ($pct_problem>=$critical) {
	print "Critical - $pct_problem% de problemas (TOTAL = $total_problem, onde $host_down hosts down, $host_unreachable hosts inalcancaveis, $service_critical servicos criticos, $service_warning servicos em alerta e $service_unknown servicos desconhecidos) |Problemas=$pct_problem%;$warning;$critical;0;100 total_problem=$total_problem hosts_down=$host_down host_unreachable=$host_unreachable service_critical=$service_critical service_warning=$service_warning service_unknown=$service_unknown\n";
	exit(2);
}elsif($pct_problem>=$warning) {
	print "Warning - $pct_problem% de problemas (TOTAL = $total_problem, onde $host_down hosts down, $host_unreachable hosts inalcancaveis, $service_critical servicos criticos, $service_warning servicos em alerta e $service_unknown servicos desconhecidos) |Problemas=$pct_problem%;$warning;$critical;0;100 total_problem=$total_problem hosts_down=$host_down host_unreachable=$host_unreachable service_critical=$service_critical service_warning=$service_warning service_unknown=$service_unknown\n";
	exit(1);
}else{
	print "OK - $pct_problem% de problemas (TOTAL = $total_problem, onde $host_down hosts down, $host_unreachable hosts inalcancaveis, $service_critical servicos criticos, $service_warning servicos em alerta e $service_unknown servicos desconhecidos) |Problemas=$pct_problem%;$warning;$critical;0;100 total_problem=$total_problem hosts_down=$host_down host_unreachable=$host_unreachable service_critical=$service_critical service_warning=$service_warning service_unknown=$service_unknown\n";
	exit(0);
}
