#!/usr/bin/php -q
<?php

include("/usr/local/opmon/etc/config.php");

$shortopts = "h";
$longopts  = array("host:", "community:", "name:", "warning:", "critical:", "list:", "help");
$options = getopt($shortopts, $longopts);
$basename = str_replace(".php", "", basename($_SERVER[PHP_SELF]));

function main() {

	global $basename;
	global $options;
	
	$warn = explode(",", $options["warning"]);
	$crit = explode(",", $options["critical"]);

	if ((sizeof($warn) < 3) or (sizeof($crit) < 3)) {
		echo "Usage: --warning and --critical = <Number of Process>,<CPU Load>,<Memory>.\n";
		help();
	}

	$query_result = do_query("CREATE TABLE IF NOT EXISTS ".$basename." (host VARCHAR(12), name VARCHAR(100), value INT NOT NULL, time INT NOT NULL)", "plugins");
	$query_result->Close();

	$arr = get_proc_info($options["name"]);
	$time = time();

	$query_result = do_query("SELECT COUNT(*) as count FROM ".$basename." WHERE host = '".$options["host"]."' AND name = '".$options["name"]."'", "plugins");
	$reg = $query_result->fields;
	$query_result->Close();

	if ($reg["count"] == 0) {
		$query_result = do_query("INSERT INTO ".$basename." (host, name, value, time) values ('".$options["host"]."', '".$options["name"]."', ".$arr["cpu"].", $time)", "plugins");
		$query_result->Close();
		quit("First check. Need wait 60 second for new check.",0);
	} else {
		$query_result = do_query("SELECT value, time FROM ".$basename." WHERE host = '".$options["host"]."' AND name = '".$options["name"]."'", "plugins");
		$reg = $query_result->fields;
		if ((($time - $reg["time"]) < 60)) {
			quit("No data return. Need wait a minim of 60 second for new check.",3);
		}
		if (($arr["cpu"] < $reg["value"])) {
			$reg["value"] = 0;
		}
		$query_result = do_query("UPDATE ".$basename." SET value=".$arr["cpu"].", time=".$time." WHERE host = '".$options["host"]."' AND name = '".$options["name"]."'", "plugins");
		$query_result->Close();
		$cpu = (($arr["cpu"] - $reg["value"]) / ($time - $reg["time"]));
		# Fixando o load de 5 minuto
		#$cpu = (($arr["cpu"] - $reg["value"]) / 300);
		$mem = $arr["mem"] / 1024;
	}

	$cnum = metric($arr["num"],$warn[0],$crit[0]);
	$ccpu = metric($cpu,$warn[1],$crit[1]);
	$cmem = metric($mem,$warn[2],$crit[2]);

	if (($cnum == 2) or ($ccpu == 2) or ($cmem == 2)) {
		$code = 2;
	} else if (($cnum == 1) or ($ccpu == 1) or ($cmem == 1)) {
		$code = 1;
	} else if (($cnum == 0) or ($ccpu == 0) or ($cmem == 0)) {
                $code = 0;
        } else {
		quit("Unable to check.",3);
	}

	$cpu = round($cpu,2);
	$mem = round($mem,3);
	quit($arr["num"]." Process ".$options["name"]." - CPU Load: $cpu % / Memory: $mem MB | process=".$arr["num"].";".$warn[0].";".$crit[0].";0; cpu=$cpu%;".$warn[1].";".$crit[1].";0;100 memory=".$mem."MB;".$warn[2].";".$crit[2].";0;",$code);

}

function get_proc_info($name) {

	global $options;
	$oid_proc_desc = "1.3.6.1.2.1.25.4.2.1.2";
	$oid_proc_cpu = "1.3.6.1.2.1.25.5.1.1.1";
	$oid_proc_mem = "1.3.6.1.2.1.25.5.1.1.2";

	if ((!$options["host"]) or (!$options["community"])) {
		echo "Need parameters, host and community.\n";
		help();
	}

	$name = $options["name"];
	$ret = snmp2_real_walk($options["host"], $options["community"], $oid_proc_desc);
	if (sizeof($ret) <= 1) {
		quit("SNMP no response, from ".$options["host"],2);
	}
	for (reset($ret); $i = key($ret); next($ret)) {
		$return = "$i: $ret[$i]";
		if ($options["list"]) {
			echo "$return\n";
		}
		if (preg_match("/.+\.(.+):\sSTRING:\s\"$name\"/", $return, $matches)) {
			$array[$matches[1]] = $name;
		}
	}

	$tnum = sizeof($array);
	if (!$name) {
		echo "Need parameters name.\n";
		help();
	} else if ($tnum == 0) {
		quit("Process by name ".$options["name"]." not found.",2);
	}

	foreach($array as $i => $v){
		$cpu = snmp2_get($options["host"], $options["community"], $oid_proc_cpu.".".$i);
		$mem = snmp2_get($options["host"], $options["community"], $oid_proc_mem.".".$i);
		if (preg_match("/INTEGER:\s(.+)/", $cpu, $matches)) {
	                $tcpu += $matches[1];
	        }
		if (preg_match("/INTEGER:\s(.+)/", $mem, $matches)) {
	                $tmem += $matches[1];
	        }
	}
	$arr = array("num" => $tnum, "mem" => $tmem, "cpu" => $tcpu);
	return $arr;

}

function quit($text, $code) {

	echo $text."\n";
	exit($code);

}

function metric($value, $warn, $crit) {

	global $options;

	if ($value >= $warn) {
		return 1;
	} else if ($value >= $crit) {
		return 2;
	} else if ($value < $warn) {
		return 0;
	} else {
		quit("Unable to check.",3);
	}

}

function help() {
	
	global $options;
	global $basename;

	echo "Parameters:\n--host\n--community\n--warning\n<Number of Process>,<CPU Load>,<Memory>\n--critical\n<Number of Process>,<CPU Load>,<Memory>\n--name\nName of process.\nOptional:\n--list\nSet 1 for list full process name. Need parameters, host and community.\nRestritions:\n* Need wait a minim of 60 second for new check.\n* Only SNMP version 2c.\nExample:\n$basename.php --host=127.0.0.1 --community=public --name=httpd --warning=2,60,200 --critical=6,80,400\n";
		exit(1);
}

main();
?>
