#!/usr/bin/perl

($warnLevel, $criticalLevel)=@ARGV;

if ($#ARGV<1) {
   print "Usage:\n";
   print "check_mem.pl <warnningLevel> <criticalLevel>\n";
   print "Example: check_mem.pl 80 95\n";
   exit(-1);
}

($total_mem,$unit_total_mem)=findValuesUnit("MemTotal:");
($stotal,$unit_cached_used)=findValuesUnit("SwapTotal:");
($sfree,$unit_cached_used)=findValuesUnit("SwapFree:");

$cache_used=$stotal-$sfree;

$percent_cache_used=(100*$cache_used)/$total_mem;
$percent_cache_used=sprintf("%.02f",$percent_cache_used);

if ($percent_cache_used>$criticalLevel) {
   print "CRITICAL - $percent_cache_used% cache utilizado|swap=$percent_cache_used%;$warnLevel;$criticalLevel;0;100\n";
   exit(2);
}
if ($percent_cache_used>$warnLevel) {
   print "WARNING - $percent_cache_used% cache utilizado|swap=$percent_cache_used%;$warnLevel;$criticalLevel;0;100\n";
   exit(1);
}
print "OK - $percent_cache_used% cache utilizado|swap=$percent_cache_used%;$warnLevel;$criticalLevel;0;100\n";
exit(0);

sub findValuesUnit {
	local ($item)=@_;
	
	$file="/proc/meminfo";
	open(FILE, $file);
	@lines=<FILE>;
	close(file);

	$value=0;
	$unit="";
	$split_pattern="[ \t]+";
	foreach $line (@lines) {
		chomp($line);
		@parts=split(/$split_pattern/, $line);
		#print "$item - <$parts[0]> <$parts[1]> <$units>\n";		
		if ($item eq $parts[0]) {
			$value=$parts[1];
			$unit=uc($parts[2]);
		}
	}
	return($value, $unit);
}

sub convertUnitsMem {
   local ($value)=@_;
   
   $notYet=1;
   $count=0;
   while($notYet==1) {
      if ($value<1024) {
         $notYet=0;
      }
      else {
         $value=$value/1024;
         $count++;
      }
   }
   $memunit="Bytes";
   if ($count==1) {
      $memunit="KB";
   }
   if ($count==2) {
      $memunit="MB";
   }
   if ($count==3) {
      $memunit="GB";
   }
   if ($count==4) {
      $memunit="TB";
   }
   $value=sprintf("%.2f",$value);
   return($value, $memunit);
}
