#!/usr/bin/php
<?php
include "/usr/local/opmon/etc/config.php";
include "/usr/local/opmon/utils/utils.php";

$day_in_the_past=time()-86400*3;
$dump_dir="/var/tmp/opmondb/";

$ignoredDBs = array('traffic', 'information_schema', 'backup', 'test');
$dbs=get_all_databases();

$nodump_found=array();
$nodump_readable=array();
$nodump_update=array();
$stat_cmd="/usr/bin/stat -t ";

$log_file_error = "/var/log/opdb-dump-errors.log";
unlink($log_file_error);

foreach($dbs as $db) {
	/* skip DBs that dont matter */
	$key=array_search($db, $ignoredDBs);
	if ($key!==FALSE)
		continue;

	$tables=get_all_table_names_db($db);
	foreach($tables as $table) {
		$dump_table=$dump_dir.$db."/".$table.".sql";
		if (file_exists($dump_table)) {
			if (is_readable($dump_table)) {
				$stat_run_cmd=$stat_cmd.$dump_table." 2>/dev/null";
				$ret_array=array();
				$stat_line=@exec($stat_run_cmd, $ret_array, $return_var);
				if ($return_var>0) {
					$nodump_readable[]=$db.".".$table;
				}
				else {
					$stat_parts=array();
					$stat_parts=preg_split("/[ \t]+/",$stat_line);
					if (isset($stat_parts[12])) {
						$mtime=$stat_parts[12];
						if ($mtime<$day_in_the_past) {
							$nodump_update[]=$db.".".$table;
						}
					}
				}
			}
			else {
				$nodump_readable[]=$db.".".$table;
			}
		}
		else {
			$nodump_found[]=$db.".".$table;
		}
	}
}

$log_error_file_found=0;
$add_msg="";
if (file_exists($log_file_error)) {
    $log_error_file_found=1;
    $add_msg="Error in dump, check file $log_file_error - ";
} 
if (count($nodump_found)>0) {
	print "CRITICAL - $add_msg".count($nodump_found)." tables without database dump ".implode(" / ", $nodump_found)."\n";
	exit(2);
}
if (count($nodump_readable)>0) {
	print "CRITICAL - $add_msg".count($nodump_readable)." tables with unreadable database dump ".implode(" / ", $nodump_readable)."\n";
	exit(2);
}
if (count($nodump_update)>0) {
	print "CRITICAL - $add_msg".count($nodump_update)." tables with database dump older than 3 days ".implode(" / ", $nodump_update)."\n";
	exit(2);
}
if ($log_error_file_found==1) {
	print "CRITICAL - $add_msg \n";
	exit(2);
}
print "OK - Database export OK\n";
exit(0);

?>
