#!/usr/bin/php
<?php
include('/usr/local/opmon/etc/config.php');
set_logged_user('opmonadmin');

$shortopts .= "h:";
$options = getopt($shortopts);
if (isset($options['h'])) {
	$host = $options['h'];
} else {
	$host = "localhost";
}

$url = sprintf(
	'https://%s/opmon/seagull/www/index.php/traffic/action/filter/',
	$host
);

$data = array(
		 'group_by'     => 'port',
		 'resolve_name' => true,
	 	);
$params = array(
		   'action'   => 'filter',
		   'jsonData' => json_encode($data),
		  );
$r = http_request($url, $params);
$a = json_decode($r);

$output="TOP 10 ports ";
$perfdata="";
$unknow_ports="";
$uports=false;
foreach ($a as $proto) {
	/* Convert bytes to MB */
	$proto->bytes = $proto->bytes/1000/1000;
	$proto->bytes = round($proto->bytes, 2);

	/* Ukn ports */
	if (isset($proto->port_name) && !is_numeric($proto->port_name)) {
		$port = $proto->port."/".$proto->port_name;
		$perfdata.= $proto->port_name."=".$proto->bytes."MB ";
	} else {
		$uports = true;
		$port = $proto->port;

		if ( ! empty($unknow_ports)) {
			$unknow_ports .= " - ";
		}

		$unknow_ports .= "Port ".$port." ".$proto->pct."%"." ".$proto->bytes."MB";
	}

	if ( ! empty($output)) {
		$output.= " - ";
	}

	$output.= $port." ".$proto->pct."%"." ".$proto->bytes."MB";

}

if (empty($output)) {
	$output = 'No data found.';
}

if ($uports===true) {
	$html = "<a href='/opmon/seagull/www/index.php/opinterface/action/redirect/";
	$html .= "?initial_page=%2Fopmon%2Fseagull%2Fmodules%2Ftraffic%2Ftemplates%2Findex.php'>";
	$html .= "CRITICAL - Unkown Ports in TOP 10 traffic ";
	$html .= "</a>";
	print $html . " - " . $unknow_ports . "\n";
	exit(2);
} else {
	print $output."\n";
}
exit(0);

?>
