#!/usr/bin/php
<?php
include('/usr/local/opmon/etc/config.php');
set_logged_user('opmonadmin');

/* Get parameters and parse ports */
$shortopts  = "";
$shortopts .= "h:p:l:";  // Required value
$options = getopt($shortopts);
if ($options === false || empty($options) || count($options, COUNT_RECURSIVE)<2) {
	print "Usage: [-h <OTA ip address>]  -l <protocol label> -p <comma separated ports> , example, -l 'BitTorrent' -p 6881,6882\n";
	exit(0);
}
$ports_line = $options['p'];
$ports = preg_split("/[\s,]+/", $options['p']);
$label = $options['l'];

/* var_dump($ports);
exit(0); */

if (isset($options['h'])) {
	$host = $options['h'];
} else {
	$host = "localhost";
}
$url = sprintf(
    'https://%s/opmon/seagull/www/index.php/traffic/action/filter/',
    $host
);

$data = array('group_by' => 'port');
$data['limit'] = array('from' => '0', 'count' => '100');
$params = array('action' => 'filter','jsonData' => json_encode($data));
$r = http_request($url,$params);
$a = json_decode($r);

$output="";
$uports=false;
foreach ($a as $proto) {
	if (array_search($proto->port, $ports)!==false) {
		$uports = true;
		/* Convert bytes to MB */
		$proto->bytes=$proto->bytes/1000/1000;
		$proto->bytes=round($proto->bytes,2);
		
		/* Ukn ports */
		if (isset($proto->port_name) && !is_numeric($proto->port_name)) {
			$port = $proto->port."/".$proto->port_name;
			$perfdata.= $proto->port_name."=".$proto->bytes."MB ";
		}
		else {
			$port = $proto->port;
		}
		if (!empty($output))
			$output.= " - ";
		$output.= $port." ".$proto->pct."%"." ".$proto->bytes."MB";
	}
}

/* Traffic detected - gets who is using it */
if ($uports===true) {
	$ips = array();
	$data = array('group_by' => 'ip_src');
	$data['limit'] = array('from' => '0', 'count' => '10');
	$data['src_port'] = $ports;
	$data['dst_port'] = $ports;
	$params = array('action' => 'filter','jsonData' => json_encode($data));
	$r = http_request($url,$params);
	$a = json_decode($r);
	foreach ($a as $ip_src) {
		if(isset($ips[$ip_src->sender])) {
			/* Convert bytes to MB and add */
			$ips[$ip_src->sender]->bytes+=$ip_src->bytes;
		}
		else {
			/* Convert bytes to MB */
			$ip_src->bytes=$ip_src->bytes;
			$ips[$ip_src->sender] = $ip_src;
		}
	}

	$data = array('group_by' => 'ip_dst');
	$data['limit'] = array('from' => '0', 'count' => '10');
	$data['src_port'] = $ports;
	$data['dst_port'] = $ports;
	$params = array('action' => 'filter','jsonData' => json_encode($data));
	$r = http_request($url,$params);
	$a = json_decode($r);
	foreach ($a as $ip_dst) {
		if(isset($ips[$ip_dst->receiver])) {
			/* Convert bytes to MB and add */
			$ips[$ip_dst->receiver]->bytes+=$ip_dst->bytes;
		}
		else {
			/* Convert bytes to MB */
			$ip_dst->bytes=$ip_dst->bytes;
			$ips[$ip_dst->receiver] = $ip_dst;
		}
	}

	$output.=" - IPs using detected ports ";
	foreach ($ips as $ip => $data) {
		/* B KB MB GB TB */
		for ($i=0;$i<5;$i++) {
			if ($data->bytes<1000) break;
			$data->bytes=$data->bytes/1000;
		}
		if ($i==0)
			$unit = "B";
		else if ($i==1)
			$unit = "KB";
		else if ($i==2)
			$unit = "MB";
		else if ($i==3)
			$unit = "GB";
		else if ($i>4)
			$unit = "TB";
		$output.= " - ".$ip." ".round($data->bytes,2).$unit;
	}
}

if ($uports===true) {
	print "<a href='/opmon/seagull/www/index.php/opinterface/action/redirect/?initial_page=%2Fopmon%2Fseagull%2Fmodules%2Ftraffic%2Ftemplates%2Findex.php'>";
	print "CRITICAL - ";
	print $label." traffic detected </a> - ".$output."\n";
	exit(2);
}
else {
	print $label." not detected\n";
}
exit(0);

?>
