#!/usr/bin/perl
#Description:
#      Get the rpm list used by OpMon
#
#Author:
#       Ricardo Marashini (ricardo.marashini@opservices.com.br)
#
#Contributions:
#	Cristiano Ness (cristiano.ness@opservices.com.br)
#       Fernando Rocha (fernando.rocha@opservices.com.br)
#
#Version:
#       1.0:            Initial release
#       1.1: 20-03-2009 Added support to list multiple rpms

use Data::Dumper;
use strict;

our $rpm = "/bin/rpm";

sub main {

        # Get opmon packages version
        my @versions = `$rpm -qa | egrep 'opmon|libmemcached|lzo2|memcached|tpl|libevent'`;

        # Remove \n and sort array
        chomp(@versions);
        @versions = sort(@versions);

        # Return string
        my $string = join(" ", @versions );
        print "$string\n";
        exit(0);

}


&main();
