#!/usr/bin/php
<?php
/*
Version: 1.0
Data: 20/08/2013

Este plugin gera dados de performance dimânicos para serem adicionados nos dashboards.

Configuração do componete no Dashboard:
	Adicionar o componete no Dashboard 
	em 'Associação' => 'Dados externos' 
	em 'Url da solicitação' => read_data_davinci.php 
	em 'Parâmetros da Solicitação' 
		 primeira linha:
			Nome => host 
			Valor => [Nome do IC do Opmon onde o serviço está configurado]
		 segunda linha:
			Nome => service 
			Valor => [Nome do AIC configurado no Opmon]

*/

include_once "functions/gapi.class.php";
include_once "functions/querys.php";

$querys = new querys;
$name = basename($_SERVER[PHP_SELF]);
$version = "1.0";

function main(){
	global $querys;

	$options = get_options();
	
	define('ga_email',$options['user']);
	define('ga_password',$options['password']);
	define('ga_profile_id',$options['profile']);
	
	$ga = new gapi(ga_email,ga_password);
	
	if($options['period'] == "undefined"){
		unset($options['start-date']);
		unset($options['end-date']);
	}else if($options['period'] != "between"){
		list($options['start_date'],$options['end_date']) = period($options['period']);
	}
	
	$arrDimensions = explode(',',$options['dimensions']);
	$arrDetrics = explode(',',$options['metrics']);
	
	if($options[verbose] >= 2) {
		var_dump($options);
	}
	$ga->requestReportData(ga_profile_id, $arrDimensions ,$arrDetrics, $options['sort'],$options['filter'] , $options['start_date'], $options['end_date']);

	$results = $ga->getResults(); 
	

	if($options[verbose] >= 2) {
		var_dump($results);
	}
	if($results == NULL){
			$msg .= "CRITICAL - Dimensions: $options[dimensions] - Metrics: $options[metrics]";
			$exit_code = 2;
		}else{
			$msg .= "OK - Dimensions: $options[dimensions] - Metrics: $options[metrics]";	
					
		}

	foreach($arrDimensions as $k => $v){
		$Dimensions[] = ucfirst($v);
	}
	
	foreach($arrDetrics as $k => $v){
		$Metrics[] = ucfirst($v);
	}
	
	foreach($results as $k => $v){
		$dimension = "";
		$m = array();
		foreach($Dimensions as $x => $y){
			$getDimension = "get".$y;
			if($x > 0) $dimension .= " ";
			
			$valor = $v->$getDimension();
			if($y == 'Date'){
				$ano = substr($valor, 0, 4);
				$mes = substr($valor, 4, 2);
				$dia = substr($valor, 6, 2);
				$valor = $dia."-".$mes."-".$ano;
			}
			$dimension .= $valor;
		}
		foreach($Metrics as $x => $y){
			$getMetric = "get".$y;
			$valor = $v->$getMetric();
			/*Caso o velor seja float convert faz arredondamento*/
			if(is_float($valor)) {
				$valor = round($valor,2);
			}
			
			$m[$y] =  $valor;
		}
		$m['label'] = $dimension;
		$result[] = $m;
	}
	//var_dump($result);
	//exit;

	list($data,$metrics) = resultArrays($result);
	//var_dump($data);
	$out = array('display_status' => 0);
	$out['metrics'] = $metrics;
	$out['data'] = $data;


	$key = $options[ic].$options[aic];
	$data = json_encode($out);

	if($options[verbose] >= 1) {
		print"key: $key\n";
		var_dump($data);
	}

	/*adiciona ao banco do opmon*/
	$querys->setUtf8();
	$existe_tabela = $querys->verify_table();
	if( $existe_tabela == 0){
	print "criar tabela";
	$querys->create_table_customhandlers();
	}

	$exit_code = $querys->set_values($key, $data);
	
	quit($msg,$exit_code);
} 
 	
function secToH($sec){
    $hms = "";
    $hours = intval(intval($sec) / 3600);
    $hms .= ($padHours) 
          ? str_pad($hours, 2, "0", STR_PAD_LEFT). ':'
          : $hours. ':';
    $minutes = intval(($sec / 60) % 60); 
    $hms .= str_pad($minutes, 2, "0", STR_PAD_LEFT). ':';
    $seconds = intval($sec % 60);
    $hms .= str_pad($seconds, 2, "0", STR_PAD_LEFT);
   	return $hms;
   }  
   
function resultArrays($arr) {
//var_dump($arr);
	foreach($arr[0] as $k => $v){
		if ($k != 'label') {
					$metrics[] = array('metric'=>$k, 'value' => $v);// 'max' => 100,  'min' => 0, 'unit' => '%'
		}
	}
	$res[0] = $arr;
	$res[1] = $metrics;
	return $res;
}

function quit($text, $code) {
	echo $text."\n";
	exit($code);
}

function get_options() {

 	$shortopts  = "I:A:v:U:P:i:d:m:f:o:p:s:e:zh";
	$longopts  = array(
						"ic:",
						"aic:",
						"verbose:",
						"user:",
						"password:",
						"profile:", //Profile Site
						"dimensions:",
						"metrics:",
						"filters:",
						"sort:",
						"period:",
						"start_date:",
						"end_date:",
						"parameters",
	 					"help"
	 					); 	
 
 	$options = getopt($shortopts, $longopts);

	if($options[I]) $options['ic'] = $options[I]; unset($options[I]);
	if($options[A]) $options['aic'] = $options[A]; unset($options[A]);
	if($options[v]) $options['verbose'] = $options[v]; unset($options[v]);
	if($options[U]) $options['user'] = $options[U]; unset($options[U]);
	if($options[P]) $options['password'] = $options[P]; unset($options[P]);
	if($options[i]) $options['profile'] = $options[i]; unset($options[i]);
	if($options[d]) $options['dimensions'] = $options[d]; unset($options[d]);
	if($options[m]) $options['metrics'] = $options[m]; unset($options[m]);
	if($options[f]) $options['filters'] = $options[f]; unset($options[f]);
	if($options[o]) $options['sort'] = $options[o]; unset($options[o]);
	if($options[p]) $options['period'] = $options[p]; unset($options[p]);
	if($options[s]) $options['start_date'] = $options[s]; unset($options[s]);
	if($options[e]) $options['end_date'] = $options[e]; unset($options[e]);

	if(isset($options['help']) || isset($options['h'])){
		help();
	}
	if(isset($options['parameters']) || isset($options['z'])){
		help(1);
	}

	if(count($options) < 8) help();

 	return $options;
}
	function period($periodo) {
 		$ano = date("Y");
		$mes = date("m");
		$dia = date("d");
		$hoje = "$ano-$mes-$dia";
	
		 switch ($periodo) {
			case "thismonth":
				$date_start = "$ano-$mes-01";
				$date_end = "$ano-$mes-31";
				return array($date_start, $date_end);
				break;
			case "thisweek":
				$semana = date("w");
				$domingo = SubDayIntoDate($hoje, $semana);
				$date_start = "$domingo";
				$date_end = "$hoje";
				return array($date_start, $date_end);
				break;
			case "last7days":
				$sevendays = SubDayIntoDate($hoje, 7);
				$date_start = "$sevendays";
				$date_end = "$hoje";
				return array($date_start, $date_end);
				break;
			case "lastmonth":
				$mespassado = mktime ( 0, 0, 0, $mes - 1, $dia, $ano );
			 	$di = strftime("%Y-%m-01", $mespassado);
				$df = strftime("%Y-%m-31", $mespassado);
				$date_start = "$di";
				$date_end = "$df";
				return array($date_start, $date_end);
				break;
		case "today":
				$date_start = "$hoje";
				$date_end = "$hoje";
				return array($date_start, $date_end);
				break;
			case "thisyear":
				$date_start = "$ano-01-01";
				$date_end = "$ano-12-31";
				return array($date_start, $date_end);
				break;
			case "yesterday":
				$yesterday = SubDayIntoDate($hoje, 1);
				$date_start = "$yesterday";
				$date_end = "$yesterday";
				return array($date_start, $date_end);
				break;
		 }
	}
function subDayIntoDate($date,$days) {
	$thisyear = substr ( $date, 0, 4 );
	$thismonth = substr ( $date, 5, 2 );
	$thisday =  substr ( $date, 8, 2 );
	$nextdate = mktime ( 0, 0, 0, $thismonth, $thisday - $days, $thisyear );
	return strftime("%Y-%m-%d", $nextdate);
}
 
function help($option) {
	
	global $name, $version;
	if($option >= 1 ){
		$dimensionsAndMetrics = "
Dimensions e Metrics:
	Tipo: Visitor
		Dimensions:
			visitorType
			visitCount
			daysSinceLastVisit
			userDefinedValue
		Metrics:
			visitors
			newVisits
			percentNewVisits

	Tipo: Session
		Dimensions:
			visitLength
		Metrics:
			visits
			bounces
			entranceBounceRate
			visitBounceRate
			timeOnSite
			avgTimeOnSite

	Tipo: Traffic Sources
		Dimensions:
			referralPath
			fullReferrer
			campaign
			source
			medium
			sourceMedium
			keyword
			adContent
			socialNetwork
			hasSocialSourceReferral
		Metrics:
			organicSearches

	Tipo: AdWords
		Dimensions:
			adGroup
			adSlot
			adSlotPosition
			adDistributionNetwork
			adMatchType
			adMatchedQuery
			adPlacementDomain
			adPlacementUrl
			adFormat
			adTargetingType
			adTargetingOption
			adDisplayUrl
			adDestinationUrl
			adwordsCustomerID
			adwordsCampaignID
			adwordsAdGroupID
			adwordsCreativeID
			adwordsCriteriaID
		Metrics:
			impressions
			adClicks
			adCost
			CPM
			CPC
			CTR
			costPerTransaction
			costPerGoalConversion
			costPerConversion
			RPC
			ROI
			margin

	Tipo: Goal Conversions
		Dimensions:
			goalCompletionLocation
			goalPreviousStep1
			goalPreviousStep2
			goalPreviousStep3
		Metrics:
			goalXXStarts
			goalStartsAll
			goalXXCompletions
			goalCompletionsAll
			goalXXValue
			goalValueAll
			goalValuePerVisit
			goalXXConversionRate
			goalConversionRateAll
			goalXXAbandons
			goalAbandonsAll
			goalXXAbandonRate
			goalAbandonRateAll

	Tipo: Platform / Device
		Dimensions:
			browser
			browserVersion
			operatingSystem
			operatingSystemVersion
			deviceCategory
			isMobile
			isTablet
			mobileDeviceBranding
			mobileDeviceMarketingName
			mobileDeviceModel
			mobileInputSelector
			mobileDeviceInfo 
	 
	Tipo: Geo / Network
		Dimensions:
			continent
			subContinent
			country
			region
			metro
			city
			latitude
			longitude
			networkDomain
			networkLocation  

	Tipo: System
		Dimensions:
			flashVersion
			javaEnabled
			language
			screenColors
			screenResolution  
	Tipo: Social Activities
		Dimensions:
			socialActivityEndorsingUrl
			socialActivityDisplayName
			socialActivityPost
			socialActivityTimestamp
			socialActivityUserHandle
			socialActivityUserPhotoUrl
			socialActivityUserProfileUrl
			socialActivityContentUrl
			socialActivityTagsSummary
			socialActivityAction
			socialActivityNetworkAction
		Metrics:
			socialActivities

	Tipo: Page Tracking
		Dimensions:
			hostname
			pagePath
			pagePathLevel1
			pagePathLevel2
			pagePathLevel3
			pagePathLevel4
			pageTitle
			landingPagePath
			secondPagePath
			exitPagePath
			previousPagePath
			nextPagePath
			pageDepth
		Metrics:
			entrances
			entranceRate
			pageviews
			pageviewsPerVisit
			uniquePageviews
			pageValue
			timeOnPage
			avgTimeOnPage
			exits
			exitRate

	Tipo: Internal Search
		Dimensions:
			searchUsed
			searchKeyword
			searchKeywordRefinement
			searchCategory
			searchStartPage
			searchDestinationPage
		Metrics:
			searchResultViews
			searchUniques
			avgSearchResultViews
			searchVisits
			percentVisitsWithSearch
			searchDepth
			avgSearchDepth
			searchRefinements
			percentSearchRefinements
			searchDuration
			avgSearchDuration
			searchExits
			searchExitRate
			searchGoalXXConversionRate
			searchGoalConversionRateAll
			goalValueAllPerSearch

	Tipo: Site Speed
		Metrics:
			pageLoadTime
			pageLoadSample
			avgPageLoadTime
			domainLookupTime
			avgDomainLookupTime
			pageDownloadTime
			avgPageDownloadTime
			redirectionTime
			avgRedirectionTime
			serverConnectionTime
			avgServerConnectionTime
			serverResponseTime
			avgServerResponseTime
			speedMetricsSample
			domInteractiveTime
			avgDomInteractiveTime
			domContentLoadedTime
			avgDomContentLoadedTime
			domLatencyMetricsSample

	Tipo: App Tracking
		Dimensions:
			appName
			appId
			appVersion
			appInstallerId
			landingScreenName
			screenName
			exitScreenName
			screenDepth
		Metrics:
			appviews
			uniqueAppviews
			appviewsPerVisit
			screenviews
			uniqueScreenviews
			screenviewsPerSession
			timeOnScreen
			avgScreenviewDuration

	Tipo: Event Tracking
		Dimensions:
			eventCategory
			eventAction
			eventLabel
		Metrics:
			totalEvents
			uniqueEvents
			eventValue
			avgEventValue
			visitsWithEvent
			eventsPerVisitWithEvent
	
	Tipo: Ecommerce
		Dimensions:
			transactionId
			affiliation
			visitsToTransaction
			daysToTransaction
			productSku
			productName
			productCategory
			currencyCode
		Metrics:
			transactions
			transactionsPerVisit
			transactionRevenue
			revenuePerTransaction
			transactionRevenuePerVisit
			transactionShipping
			transactionTax
			totalValue
			itemQuantity
			uniquePurchases
			revenuePerItem
			itemRevenue
			itemsPerPurchase
			localItemRevenue
			localTransactionRevenue
			localTransactionTax
			localTransactionShipping

	Tipo: Social Interactions
		Dimensions:
			socialInteractionNetwork
			socialInteractionAction
			socialInteractionNetworkAction
			socialInteractionTarget
			socialEngagementType
		Metrics:
			socialInteractions
			uniqueSocialInteractions
			socialInteractionsPerVisit

	Tipo: User Timings
		Dimensions:
			userTimingCategory
			userTimingLabel
			userTimingVariable
		Metrics:
			userTimingValue
			userTimingSample
			avgUserTimingValue

	Tipo: Exception Tracking
		Dimensions:
			exceptionDescription
		Metrics:
			exceptions
			exceptionsPerScreenview
			fatalExceptions
			fatalExceptionsPerScreenview

	Tipo: Experiments
		Dimensions:
			experimentId
			experimentVariant  

	Tipo: Custom Variables or Columns
		Dimensions:
			customVarNameXX
			customVarValueXX
			dimensionXX
		Metrics:
			metricXX

	Tipo: Time
		Dimensions:
			date
			year
			month
			week
			day
			hour
			yearMonth
			yearWeek
			dateHour
			nthMonth
			nthWeek
			nthDay
			isoWeek
			dayOfWeek
			dayOfWeekName  ";
	}else{
		$dimensionsAndMetrics = NULL;
	}

	$msg = "$name - Versao: $version \n
Este plugin gera dados de performance dimânicos para serem adicionados nos dashboards.

Configuração do componete no Dashboard:
\tAdicionar o componete no Dashboard 
\tem 'Associação' => 'Dados externos' 
\tem 'Url da solicitação' => read_data_davinci.php 
\tem 'Parâmetros da Solicitação' 
\t\t primeira linha:
\t\t\tNome => host 
\t\t\tValor => [Nome do IC do Opmon onde o serviço está configurado]
\t\t segunda linha:
\t\t\tNome => service 
\t\t\tValor => [Nome do AIC configurado no Opmon]
	
Uso:
	$name [opcoes]
	
Opcoes:
	-I, --ic *
		Nome do IC onde este servico esta rodando no OpMon
	-A, --aic *
		Nome do AIC onde este servico esta rodando no OpMon
	-v, --verbose
		[1,2,...]
	-h , --help 
		Mostra as opcoes do plugin
	-U, --user *
		Usuario do Google Analytics
	-P, --password *
		Senha do Google Analytics
	-i, --profile *
		id do Site
	-d, --dimensions *
		[string,string,...] Usar o [-z || --parameters] para ver as opcoes
	-m, --metrics *
		[string,string,...] Usar o [-z || --parameters] para ver as opcoes
	-f, --filters
	-o, --sort
	-p, --period *
		[between] Usar em conjunto com start_date e end_date\n\t\t[thismonth] \n\t\t[thisweek] \n\t\t[yesterday] \n\t\t[last7days] \n\t\t[lastmonth] \n\t\t[thisyear] \n\t\t[today]
	-s, --start_date
		'yyyy-mm-dd'
	-e, --end_date
		'yyyy-mm-dd'
	-z , --parameters 
		Mostra as opcoes de Dimensions e Metrics
		
$dimensionsAndMetrics
Notas:
	Os parametros  dimensions, metrics , filters , sort devem ser especificados de acordo com documentacao oficial:
	https://developers.google.com/analytics/devguides/reporting/core/dimsmets

	Exemplo de utilizacao das dimensions e metrics em:
		http://ga-dev-tools.appspot.com/explorer/

Exemplo de uso do plugin:
\t./$name -I ic -A aic -U user -P password -i profile -d browser -m visits -p thismonth -o '-visits'";
	quit($msg,3);
}

main();	
?>

