#!/usr/bin/php
<?php
// @codingStandardsIgnoreFile
/**
* Autor: Cleber Campanel - cleber.motta@opservices.com.br
* Version: 1.0
* Data: 20/08/2013
*
* Este plugin gera dados de performance dinânicos para serem adicionados nos dashboards.
*
* Configuração do componete no Dashboard:
*     Adicionar o componete no Dashboard
*     em 'Associação' => 'Dados externos'
*     em 'Url da solicitação' => read_data_davinci.php
*     em 'Parâmetros da Solicitação'
*          primeira linha:
*             Nome => host
*             Valor => [Nome do IC do Opmon onde o serviço está configurado]
* da linha:
*             Nome => service
*             Valor => [Nome do AIC configurado no Opmon]
*/
include_once "gapi.class.php";

$name = basename($_SERVER[PHP_SELF]);
$version = "2.0";

function main()
{

  $options = get_options();


  $ga = new gapi($options['service_account'],$options['encripted_file']);

  if ($options['period'] == "undefined") {
  } elseif ($options['period'] != "between") {
    list($options['start_date'],$options['end_date']) = period($options['period']);
  }

  $arrDimensions = explode(',', $options['dimensions']);
  $arrDetrics = explode(',', $options['metrics']);
  if ($options[verbose] >= 2) {
    var_dump($options);
  }

  $ga->requestReportData(
  $options['profile'],
  $arrDimensions,
  $arrDetrics,
  $options['sort'],
  $options['filter'],
  $options['start_date'],
  $options['end_date']
);


$results = $ga->getResults();


//print_r($results); exit;

/* Faz a soma das métricas a partir da dimensão escolhida */

foreach($ga->getResults() as $resultado)
{
  $method = 'get'.$options[metrics];
  $total = $total + $resultado->$method();

}


if ($options[verbose] >= 2) {
  var_dump($results);
}
if ($results == null) {

  $msg .= "CRITICAL - Dimensions: $options[dimensions] - Metrics: $options[metrics]";
  $exit_code = 2;

} else {
  $msg .= "OK - Dimensions: $options[dimensions] - Metrics: $total $options[metrics] | '$options[metrics]'=$total;0;0;0;";
}


foreach ($arrDimensions as $k => $v) {
  $Dimensions[] = ucfirst($v);
}

foreach ($arrDetrics as $k => $v) {
  $Metrics[] = ucfirst($v);
}

foreach ($results as $k => $v) {
  $dimension = "";
  $m = array();
  foreach ($Dimensions as $x => $y) {
    $getDimension = "get".$y;
    if ($x > 0) {
      $dimension .= " ";
    }

    $valor = $v->$getDimension();
    if ($y == 'Date') {
      $ano = substr($valor, 0, 4);
      $mes = substr($valor, 4, 2);
      $dia = substr($valor, 6, 2);
      $valor = $dia."-".$mes."-".$ano;
    }
    $dimension .= $valor;
  }
  foreach ($Metrics as $x => $y) {
    $getMetric = "get".$y;
    $valor = $v->$getMetric();
    /*Caso o va'lor seja float convert faz arredondamento*/
    if (is_float($valor)) {
      $valor = round($valor, 2);
    }

    $m[$y] =  $valor;
  }
  $m['label'] = $dimension;
  $result[] = $m;
}
//var_dump($result);
//exit;

list($data,$metrics) = resultArrays($result);
//var_dump($data);
$out = array('display_status' => 0);
$out['metrics'] = $metrics;
$out['data'] = $data;


$key = $options[ic].$options[aic];
$data = json_encode($out);

if ($options[verbose] >= 1) {
  print"key: $key\n";
  var_dump($data);
}


quit($msg, $exit_code);
}


function secToH($sec)
{
  $hms = "";
  $hours = intval(intval($sec) / 3600);
  $hms .= ($padHours)
  ? str_pad($hours, 2, "0", STR_PAD_LEFT).':'
  : $hours. ':';
  $minutes = intval(($sec / 60) % 60);
  $hms .= str_pad($minutes, 2, "0", STR_PAD_LEFT). ':';
  $seconds = intval($sec % 60);
  $hms .= str_pad($seconds, 2, "0", STR_PAD_LEFT);
  return $hms;
}

function resultArrays($arr)
{
  //var_dump($arr);
  foreach ($arr[0] as $k => $v) {
    if ($k != 'label') {
      $metrics[] = array('metric'=>$k, 'value' => $v);// 'max' => 100,  'min' => 0, 'unit' => '%'
    }
  }
  $res[0] = $arr;
  $res[1] = $metrics;
  return $res;
}

function quit($text, $code)
{
  echo $text."\n";
  exit($code);
}

function get_options()
{

  $shortopts  = "I:A:v:U:P:i:d:m:f:o:p:s:e:zh:g:l:";
  $longopts  = array(
    "ic:",
    "aic:",
    "verbose:",
    "user:",
    "password:",
    "profile:", //Profile Site
    "dimensions:",
    "metrics:",
    "filters:",
    "sort:",
    "period:",
    "start_date:",
    "end_date:",
    "parameters",
    "help",
    "service_account:",//google service account
    "encripted_file:",// .P12 file
  );

  $options = getopt($shortopts, $longopts);

  if ($options[I]) {
    $options['ic'] = $options[I];

  } unset($options[I]);
  if ($options[A]) {
    $options['aic'] = $options[A];

  } unset($options[A]);
  if ($options[v]) {
    $options['verbose'] = $options[v];

  } unset($options[v]);
  if ($options[U]) {
    $options['user'] = $options[U];

  } unset($options[U]);
  if ($options[P]) {
    $options['password'] = $options[P];

  } unset($options[P]);
  if ($options[i]) {
    $options['profile'] = $options[i];

  } unset($options[i]);
  if ($options[d]) {
    $options['dimensions'] = $options[d];

  } unset($options[d]);
  if ($options[m]) {
    $options['metrics'] = $options[m];

  } unset($options[m]);
  if ($options[f]) {
    $options['filters'] = $options[f];

  } unset($options[f]);
  if ($options[o]) {
    $options['sort'] = $options[o];

  } unset($options[o]);
  if ($options[p]) {
    $options['period'] = $options[p];

  } unset($options[p]);
  if ($options[s]) {
    $options['start_date'] = $options[s];

  } unset($options[s]);
  if ($options[e]) {
    $options['end_date'] = $options[e];

  } unset($options[e]);
  if ($options[g]) {
    $options['service_account'] = $options[g];

  }unset($options[g]);
  if($options[l]){
    $options['encripted_file'] = $options[l];

  }unset($options[l]);



  if (isset($options['help']) || isset($options['h'])) {
    help();
  }
  if (isset($options['parameters']) || isset($options['z'])) {
    help(1);
  }

  if (count($options) < 8) {
    help();
  }

  return $options;
}


function period($periodo)
{
  $ano = date("Y");
  $mes = date("m");
  $dia = date("d");
  $hoje = "$ano-$mes-$dia";

  switch ($periodo) {
    case "thismonth":
    $date_start = "$ano-$mes-01";
    $date_end = "$ano-$mes-31";
    return array($date_start, $date_end);
    break;
    case "thisweek":
    $semana = date("w");
    $domingo = SubDayIntoDate($hoje, $semana);
    $date_start = "$domingo";
    $date_end = "$hoje";
    return array($date_start, $date_end);
    break;
    case "last7days":
    $sevendays = SubDayIntoDate($hoje, 7);
    $date_start = "$sevendays";
    $date_end = "$hoje";
    return array($date_start, $date_end);
    break;
    case "lastmonth":
    $mespassado = mktime(0, 0, 0, $mes - 1, $dia, $ano);
    $di = strftime("%Y-%m-01", $mespassado);
    $df = strftime("%Y-%m-31", $mespassado);
    $date_start = "$di";
    $date_end = "$df";
    return array($date_start, $date_end);
    break;
    case "today":
    $date_start = "$hoje";
    $date_end = "$hoje";
    return array($date_start, $date_end);
    break;
    case "thisyear":
    $date_start = "$ano-01-01";
    $date_end = "$ano-12-31";
    return array($date_start, $date_end);
    break;
    case "yesterday":
    $yesterday = SubDayIntoDate($hoje, 1);
    $date_start = "$yesterday";
    $date_end = "$yesterday";
    return array($date_start, $date_end);
    break;
  }
}

function subDayIntoDate($date, $days)
{
  $thisyear = substr($date, 0, 4);
  $thismonth = substr($date, 5, 2);
  $thisday =  substr($date, 8, 2);
  $nextdate = mktime(0, 0, 0, $thismonth, $thisday - $days, $thisyear);
  return strftime("%Y-%m-%d", $nextdate);
}

function help($option)
{

  global $name, $version;
  if ($option >= 1) {
    $dimensionsAndMetrics = "
    Dimensions e Metrics:
    Tipo: Visitor
    Dimensions:
    visitorType
    visitCount
    daysSinceLastVisit
    userDefinedValue
    Metrics:
    visitors
    newVisits
    percentNewVisits

    Tipo: Session
    Dimensions:
    visitLength
    Metrics:
    visits
    bounces
    entranceBounceRate
    visitBounceRate
    timeOnSite
    avgTimeOnSite

    Tipo: Traffic Sources
    Dimensions:
    referralPath
    fullReferrer
    campaign
    source
    medium
    sourceMedium
    keyword
    adContent
    socialNetwork
    hasSocialSourceReferral
    Metrics:
    organicSearches

    Tipo: AdWords
    Dimensions:
    adGroup
    adSlot
    adSlotPosition
    adDistributionNetwork
    adMatchType
    adMatchedQuery
    adPlacementDomain
    adPlacementUrl
    adFormat
    adTargetingType
    adTargetingOption
    adDisplayUrl
    adDestinationUrl
    adwordsCustomerID
    adwordsCampaignID
    adwordsAdGroupID
    adwordsCreativeID
    adwordsCriteriaID
    Metrics:
    impressions
    adClicks
    adCost
    CPM
    CPC
    CTR
    costPerTransaction
    costPerGoalConversion
    costPerConversion
    RPC
    ROI
    margin

    Tipo: Goal Conversions
    Dimensions:
    goalCompletionLocation
    goalPreviousStep1
    goalPreviousStep2
    goalPreviousStep3
    Metrics:
    goalXXStarts
    goalStartsAll
    goalXXCompletions
    goalCompletionsAll
    goalXXValue
    goalValueAll
    goalValuePerVisit
    goalXXConversionRate
    goalConversionRateAll
    goalXXAbandons
    goalAbandonsAll
    goalXXAbandonRate
    goalAbandonRateAll

    Tipo: Platform / Device
    Dimensions:
    browser
    browserVersion
    operatingSystem
    operatingSystemVersion
    deviceCategory
    isMobile
    isTablet
    mobileDeviceBranding
    mobileDeviceMarketingName
    mobileDeviceModel
    mobileInputSelector
    mobileDeviceInfo

    Tipo: Geo / Network
    Dimensions:
    continent
    subContinent
    country
    region
    metro
    city
    latitude
    longitude
    networkDomain
    networkLocation

    Tipo: System
    Dimensions:
    flashVersion
    javaEnabled
    language
    screenColors
    screenResolution
    Tipo: Social Activities
    Dimensions:
    socialActivityEndorsingUrl
    socialActivityDisplayName
    socialActivityPost
    socialActivityTimestamp
    socialActivityUserHandle
    socialActivityUserPhotoUrl
    socialActivityUserProfileUrl
    socialActivityContentUrl
    socialActivityTagsSummary
    socialActivityAction
    socialActivityNetworkAction
    Metrics:
    socialActivities

    Tipo: Page Tracking
    Dimensions:
    hostname
    pagePath
    pagePathLevel1
    pagePathLevel2
    pagePathLevel3
    pagePathLevel4
    pageTitle
    landingPagePath
    secondPagePath
    exitPagePath
    previousPagePath
    nextPagePath
    pageDepth
    Metrics:
    entrances
    entranceRate
    pageviews
    pageviewsPerVisit
    uniquePageviews
    pageValue
    timeOnPage
    avgTimeOnPage
    exits
    exitRate

    Tipo: Internal Search
    Dimensions:
    searchUsed
    searchKeyword
    searchKeywordRefinement
    searchCategory
    searchStartPage
    searchDestinationPage
    Metrics:
    searchResultViews
    searchUniques
    avgSearchResultViews
    searchVisits
    percentVisitsWithSearch
    searchDepth
    avgSearchDepth
    searchRefinements
    percentSearchRefinements
    searchDuration
    avgSearchDuration
    searchExits
    searchExitRate
    searchGoalXXConversionRate
    searchGoalConversionRateAll
    goalValueAllPerSearch

    Tipo: Site Speed
    Metrics:
    pageLoadTime
    pageLoadSample
    avgPageLoadTime
    domainLookupTime
    avgDomainLookupTime
    pageDownloadTime
    avgPageDownloadTime
    redirectionTime
    avgRedirectionTime
    serverConnectionTime
    avgServerConnectionTime
    serverResponseTime
    avgServerResponseTime
    speedMetricsSample
    domInteractiveTime
    avgDomInteractiveTime
    domContentLoadedTime
    avgDomContentLoadedTime
    domLatencyMetricsSample

    Tipo: App Tracking
    Dimensions:
    appName
    appId
    appVersion
    appInstallerId
    landingScreenName
    screenName
    exitScreenName
    screenDepth
    Metrics:
    appviews
    uniqueAppviews
    appviewsPerVisit
    screenviews
    uniqueScreenviews
    screenviewsPerSession
    timeOnScreen
    avgScreenviewDuration

    Tipo: Event Tracking
    Dimensions:
    eventCategory
    eventAction
    eventLabel
    Metrics:
    totalEvents
    uniqueEvents
    eventValue
    avgEventValue
    visitsWithEvent
    eventsPerVisitWithEvent

    Tipo: Ecommerce
    Dimensions:
    transactionId
    affiliation
    visitsToTransaction
    daysToTransaction
    productSku
    productName
    productCategory
    currencyCode
    Metrics:
    transactions
    transactionsPerVisit
    transactionRevenue
    revenuePerTransaction
    transactionRevenuePerVisit
    transactionShipping
    transactionTax
    totalValue
    itemQuantity
    uniquePurchases
    revenuePerItem
    itemRevenue
    itemsPerPurchase
    localItemRevenue
    localTransactionRevenue
    localTransactionTax
    localTransactionShipping

    Tipo: Social Interactions
    Dimensions:
    socialInteractionNetwork
    socialInteractionAction
    socialInteractionNetworkAction
    socialInteractionTarget
    socialEngagementType
    Metrics:
    socialInteractions
    uniqueSocialInteractions
    socialInteractionsPerVisit

    Tipo: User Timings
    Dimensions:
    userTimingCategory
    userTimingLabel
    userTimingVariable
    Metrics:
    userTimingValue
    userTimingSample
    avgUserTimingValue

    Tipo: Exception Tracking
    Dimensions:
    exceptionDescription
    Metrics:
    exceptions
    exceptionsPerScreenview
    fatalExceptions
    fatalExceptionsPerScreenview

    Tipo: Experiments
    Dimensions:
    experimentId
    experimentVariant

    Tipo: Custom Variables or Columns
    Dimensions:
    customVarNameXX
    customVarValueXX
    dimensionXX
    Metrics:
    metricXX

    Tipo: Time
    Dimensions:
    date
    year
    month
    week
    day
    hour
    yearMonth
    yearWeek
    dateHour
    nthMonth
    nthWeek
    nthDay
    isoWeek
    dayOfWeek
    dayOfWeekName  ";
  } else {

    $dimensionsAndMetrics = null;
  }

  $msg = "$name - Versao: $version \n
  Este plugin gera dados de performance dimânicos para serem adicionados nos dashboards.

  Configuração do componete no Dashboard:
  \tAdicionar o componete no Dashboard
  \tem 'Associação' => 'Dados externos'
  \tem 'Url da solicitação' => read_data_davinci.php
  \tem 'Parâmetros da Solicitação'
  \t\t primeira linha:
  \t\t\tNome => host
  \t\t\tValor => [Nome do IC do Opmon onde o serviço está configurado]
  \t\t segunda linha:
  \t\t\tNome => service
  \t\t\tValor => [Nome do AIC configurado no Opmon]

  Uso:
  $name [opcoes]

  Opcoes:
  -I, --ic *
  Nome do IC onde este servico esta rodando no OpMon
  -A, --aic *
  Nome do AIC onde este servico esta rodando no OpMon
  -v, --verbose
  [1,2,...]
  -h , --help
  Mostra as opcoes do plugin
  -U, --user *
  Usuario do Google Analytics
  -P, --password *
  Senha do Google Analytics
  -i, --profile *
  id do Site
  -d, --Dimensions * Utilizar between e com os parâmetros das datas quando selecionar a dimensão year
  [string,string,...] Usar o [-z || --parameters] para ver as opcoes
  -m, --metrics *
  [string,string,...] Usar o [-z || --parameters] para ver as opcoes
  -f, --filters
  -o, --sort
  -p, --period *
  \t\t[between] Usar em conjunto com start_date e end_date
  \t\t[thisweek]
  \t\t[yesterday]
  \t\t[last7days]
  \t\t[lastmonth]
  \t\t[thisyear]
  \t\t[today]
  -s, --start_date
  'yyyy-mm-dd'
  -e, --end_date
  'yyyy-mm-dd'
  -z , --parameters
  Mostra as opcoes de Dimensions e Metrics

  $dimensionsAndMetrics
  Notas:
  Os parametros  dimensions, metrics , filters , sort devem ser especificados de acordo com documentacao oficial:
    https://developers.google.com/analytics/devguides/reporting/core/dimsmets

    Dimensão visits é equivalente a sessions

    Exemplo de utilizacao das dimensions e metrics em:
    http://ga-dev-tools.appspot.com/explorer/

    Exemplo de uso do plugin:
    \t./$name -I ic -A aic -i profile -d month -m pageviews -p yesterday  -g service account -l encripted file(filename)
    ./analyticsTeste.php -I 'Loja_Virtual' -A 'Usuarios_Conectados' -i 1296857 -m pageviews -d month -g 'opservices-onc@appspot.gserviceaccount.com' -p year -l 'nova.p12'

    DICAS - Instruções de Comandos Google Analytics


    -> Pesquisa semana passada

    ./google_analytics.php -I 'Loja_Virtual' -A 'Usuarios_Conectados' -i 1296857 -m sessions -d month -g 'opservices-onc@appspot.gserviceaccount.com' -l 'nova.p12' -p between -s 'start_date' -e 'end_date'

    -> Pesquisa ontem

    ./google_analytics.php -I 'Loja_Virtual' -A 'Usuarios_Conectados' -i 1296857 -m sessions -d day -g 'opservices-onc@appspot.gserviceaccount.com' -l 'nova.p12' -p yesterday

    -> Pesquisa mês passado

    ./google_analytics.php -I 'Loja_Virtual' -A 'Usuarios_Conectados' -i 1296857 -m sessions -d month -g 'opservices-onc@appspot.gserviceaccount.com' -l 'nova.p12' -p lastmonth

    -> Pesquisa últimos 7 dias

    ./google_analytics.php -I 'Loja_Virtual' -A 'Usuarios_Conectados' -i 1296857 -m sessions -d day -g 'opservices-onc@appspot.gserviceaccount.com' -l 'nova.p12' -p between -s 2016-06-10 -e 2016-06-16

    -> Pesquisa últimos 30 dias

    ./google_analytics.php -I 'Loja_Virtual' -A 'Usuarios_Conectados' -i 1296857 -m sessions -d month -g 'opservices-onc@appspot.gserviceaccount.com' -l 'nova.p12' -p between -s 2016-05-18 -e 2016-06-16

    -> Pesquisa hoje (Pode ter uma variação de dois ou 3 números por ser realtime)

    ./google_analytics.php -I 'Loja_Virtual' -A 'Usuarios_Conectados' -i 1296857 -m sessions -d day -g 'opservices-onc@appspot.gserviceaccount.com' -l 'nova.p12' -p today

    -> Pesquisa Anual até hoje

    ./google_analytics.php -I 'Loja_Virtual' -A 'Usuarios_Conectados' -i 1296857 -m sessions -d year -g 'opservices-onc@appspot.gserviceaccount.com' -l 'nova.p12' -p thisyear

    -> Pesquisa ano passado

    ./google_analytics.php -I 'Loja_Virtual' -A 'Usuarios_Conectados' -i 1296857 -m sessions -d year -g 'opservices-onc@appspot.gserviceaccount.com' -l 'nova.p12' -p between -s 2015-01-01 -e 2015-12-31

    -> Pesquisa desde quando começou monitoração do site

    ./google_analytics.php -I 'Loja_Virtual' -A 'Usuarios_Conectados' -i 1296857 -m sessions -d year -g 'opservices-onc@appspot.gserviceaccount.com' -l 'nova.p12' -p year

    ";

    quit($msg, 3);
  }

  main();
