<?php
//OpMon - Software Configuration Management Agent

//error_reporting(0);

$_name = 'OpSCM - Software Configuration Management Agent';
$_version = '1.1';
$_include = 'scm-files.ini';
$_include_local = 'scm-files-local.ini';
$_verbose = false;
$_sep = DIRECTORY_SEPARATOR;
$_config_dir = ($_sep == "\\") ? 'c:\opmon' : '/usr/local/opmon/libexec';
$_server_url = '/opmon/opscm/api/';
$_server_uri = '';
$_server_timeout = 10;
$_namespace = '';
$_post = array();
$_output = array();
$_exit = 0;
$_list = false;
$_cache_file = 'scm.db';
$_cache = array();
$_cache_new = array();
$_ignore_cache = false;

function l($msg,$level = 'INFO'){
    global $_verbose;
    $d = date('d/m/Y H:i:s');
    if ($_verbose) {
        print $d .' '. $level . ' ' . $msg . "\n";
    }
}

function file_put($filename, $data) {
    $f = @fopen($filename, 'w');
    if (!$f) {
        return false;
    } else {
        $bytes = fwrite($f, $data);
        fclose($f);
        return $bytes;
    }
}

function cache($cache = '') {
    global $_cache_file, $_config_dir, $_sep;
    $file = $_config_dir . $_sep . $_cache_file;
    if ($cache) {
        l('Writing cache '.$file);
        file_put($file,implode("\n",$cache));
    }
    if (is_file($file)){
        l('Reading cache');
        $t = array();
        foreach(file($file) as $k){
            list($md5p,$md5c) = explode(':',$k);
            $t[trim($md5p)] = trim($md5c);
        }
        return $t;
    } else {
        l('Cache not found '.$file,'ERROR');
        return array();
    }
}

function include_files($include_file,$required = false) {
    global $_output, $_post, $_exit, $_list, $_cache, $_cache_new;
    if ($_list) {
        print "Include file: $include_file\n";
    }
    foreach(file($include_file) as $file){
        $i = count($_post);
        $file = trim($file);
        if ($file && is_file($file)) {
            if ($_list) {
                print "File: " . $file ." - Found\n";
            }
            $md5_path = md5($file);
            $content = file_get_contents($file);
            $md5_content = md5($content);
            $content = base64_encode($content);
            $filee = urlencode($file);
            $t = "{\"md5_path\":\"$md5_path\",\"md5_content\":\"$md5_content\",\"path\":\"$filee\",\"content\":\"$content\"}";
            if (!isset($_cache[$md5_path]) || (isset($_cache[$md5_path]) && $_cache[$md5_path] != $md5_content)){
                $_post["file[$i]"] = $t;
                l("File $i: $file -> ".$t);
                $i++;
                $_cache_new[] = $md5_path.':'.$md5_content;
            } else {
                l("File cached: $file -> {$_cache[$md5_path]} = $md5_content");
            }
        } else {
            if ($required) {
                $_output[] = "File not found ($file)";
                $_exit = 1;
            }
            if ($_list) {
               print "File: " . $file ." - Not found\n";
            } else {
                l("File: " . $file ." - Not found");
            }
        }
    }
}

function http_build_post($data, $prefix='', $sep='', $key='') {
    $ret = array();
     foreach ((array)$data as $k => $v) {
            if (is_int($k) && $prefix != null) {
                $k = urlencode($prefix . $k);
            }
            if ((!empty($key)) || ($key === 0))  $k = $key.'['.urlencode($k).']';
            if (is_array($v) || is_object($v)) {
                array_push($ret, http_build_query($v, '', $sep, $k));
            } else {
                array_push($ret, $k.'='.urlencode($v));
            }
        }
        if (empty($sep)) $sep = ini_get('arg_separator.output');
        return implode($sep, $ret);
}

function jsondecode($json) {
    if ($json[0] != '{' || $json[strlen($json)-1] != '}'){
        return "";
    }
    $comment = false;
    $out = '$x=';
    for ($i=0; $i<strlen($json); $i++) {
        if (!$comment) {
            if (($json[$i] == '{') || ($json[$i] == '[')) $out .= ' array(';
            else if (($json[$i] == '}') || ($json[$i] == ']')) $out .= ')';
            else if ($json[$i] == ':') $out .= '=>';
            else $out .= $json[$i];
        } else $out .= $json[$i];
        if ($json[$i] == '"' && $json[($i-1)]!="\\")    $comment = !$comment;
    }
    @eval($out . ';');
    return $x;
}

//$options = getopt('n::s::d:vV');

foreach ($argv as $a => $arg){
  if ($arg == '-n' && isset($argv[$a + 1])) {
    $_namespace = trim($argv[$a + 1]);
  } elseif ($arg == '-s' && isset($argv[$a + 1])) {
    $_server_uri = trim($argv[$a + 1]);
  } elseif ($arg == '-d' && isset($argv[$a + 1])) {
    $_config_dir = trim($argv[$a + 1]);
  } elseif ($arg == '-v') {
    $_verbose = true;
  } elseif ($arg == '-l') {
    $_list = true;
  } elseif ($arg == '-V') {
    print "version $_version\n";
    exit(0);
  }
}

if ((empty($_server_uri) || empty($_namespace)) && !$_list ){
  print "$_name - version $_version\n";
  print "Usage: $argv[0] -s SCM_SERVER_URI -n SCM_NAMESPACE\n";
  print "-s SCM_SERVER_URI   - SCM server address. ex: 127.0.0.1, https://localhost:443\n";
  print "-n SCM_NAMESPACE    - Configuration repo namespace. ex: localhost, linux-server\n";
  print "-d CONFIG_DIR       - Base configuration directory. Default $_config_dir\n";
  print "-l                  - List included files\n";
  print "-v                  - Verbose output.\n";
  print "-V                  - Show command version.\n";
  exit(1);
}

$_server_url = $_server_uri.$_server_url;
$_namespace = urlencode($_namespace);

$_include = $_config_dir . $_sep . $_include;

$_cache = cache();

l("Processing main include file ($_include)");
if (is_file($_include)){
    include_files($_include);
} else {
    $_output[] = "$_include not found";
    $_exit = 3;
}

$_include_local = $_config_dir . $_sep . $_include_local;

l("Processing local include file ($_include_local)");
if (is_file($_include_local)){
    include_files($_include_local,true);
}

if ($_list) {
    $_exit = 3;
}

// error using $_exit <= 1
if ($_exit <= 2) {
    l("Sending ".count($_post)." files to scm server ($_server_url) namespace ($_namespace)");

    $_post['namespace'] = $_namespace;
    $_post['timestamp'] = mktime();

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_HEADER, 0);
    curl_setopt($ch, CURLOPT_VERBOSE, $_verbose);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/4.0 (compatible;)");
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
    curl_setopt($ch, CURLOPT_FORBID_REUSE, 1);
    curl_setopt($ch, CURLOPT_FRESH_CONNECT, 1);
    curl_setopt($ch, CURLOPT_TIMEOUT, $_server_timeout);
    curl_setopt($ch, CURLOPT_URL, $_server_url );
    curl_setopt($ch, CURLOPT_POSTFIELDS,  http_build_post($_post,'','&'));
    $response = curl_exec($ch);
    curl_close($ch);

    if (empty($response)){
        $_output[] = 'No response from server';
        $_exit = 3;
    } else {
        l("Server response: $response");
        $r = jsondecode(trim($response));
        if (isset($r["status"]) && is_numeric($r["status"]) && isset($r["output"])){
            $_exit = ($r['status'] > $_exit) ? $r['status'] : $_exit;
            $_output[] = urldecode($r['output']);
        } else {
            $_exit = 3;
            $_output[] = "Invalid server response";
        }
    }
}
l('Exit code: ' . $_exit);
if ($_exit == "0"){
    cache($_cache_new);
}
print implode(" - ",$_output);
exit($_exit);

?>